/'--------------------------------------------------------------------
                  Nascent World Engine for FreeBASIC              
                     Copyright Vincent DeCampo 2009      

   This program is free software: you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

--------------------------------------------------------------------'/
'

#Libpath "..\lib"
#Include "..\inc\nascentwe.bi"

#Define ScreenWidth  640
#Define ScreenHeight 480

Declare Function MovePlayer (tmEngine As _tmEngine, Object As _Object) As Integer
Declare Sub ProcessKeyboard (tmEngine As _tmEngine)
Declare Sub ProcessMouse    (tmEngine As _tmEngine)

   ScreenRes ScreenWidth,ScreenHeight,32
   WindowTitle "Nascent World Engine: v " + EngineVersion
   
   Dim As _Sound Sound
      
   Dim As _tmEngine      tmEngine 
   Dim As _CustomLayer   mist
   Dim As _Animation Ptr walking(5)
   'Dim As _CustomLayer   backdrop

   'tmEngine.Map.MakeMap(20,20)
   'tmEngine.Map.SaveMap("map.dat")
   'tmEngine.Map.LoadMap(filename,Cols,Rows)
   tmEngine.Map.LoadMap("map.dat",20,20)
   
   'Load a sprite (array of sprites 0->MaxSpriteIdx)
   'tmEngine.Sprites.LoadSprite(index, filename)
   'tmEngine.Sprites.LoadSprite(0,"images\grass.bmp")
   'tmEngine.Sprites.LoadSprite(1,"images\block.bmp")
   'tmEngine.Sprites.LoadSprite(2,"images\player.bmp")
   
   'Load a sprite sheet (array of sheets 0->MaxSheetIdx)
   'tmEngine.Sprites.LoadSheet(sheetidx, filename, tilewidth, tileheight)
   tmEngine.Sprites.LoadSheet(0, "images\testsheet.bmp",32,32)

   'backdrop.Color = 0

   mist.LoadLayer = "images\clouds.png"
   mist.speed = 1
   mist.alpha = 120
   
   tmEngine.Object(0).active = 1
   tmEngine.Object(0).SetObject(5,5)      
   tmEngine.Object(0).imgIdx = 2
   tmEngine.Object(0).rotangle=0

   tmEngine.Object(1).active = 1
   tmEngine.Object(1).SetObject(16,15)      
   tmEngine.Object(1).imgIdx = 2
   tmEngine.Object(1).rotangle=0
   
   'Add a single light source 
   'tmEngine.Map.lightsource = @tmEngine.Object(0)
   
   'Add an animation to an object
   'Constructor _Animation(sheetidx, startframe, stopframe,fps, loop)
   'tmEngine.Object(0).Animation = New _Animation(0,0,7,5,1)
   
   walking(0) = New _Animation(0,0,7,10,1)
   walking(1) = New _Animation(0,8,15,10,1)
   walking(2) = New _Animation(0,16,23,10,1)
   walking(3) = New _Animation(0,24,31,10,1)
   walking(4) = New _Animation(0,32,39,10,1)
   walking(5) = New _Animation(0,40,47,10,1)
   
   tmEngine.Object(0).Animation = walking(4)
   tmEngine.Object(1).Animation = walking(4)
   
   'Add an animation to the map (array of animations 0->MaxAnimationIdx)
   'Constructor _Animation(sheetidx, startframe, stopframe,fps, loop)
   'tmEngine.Map.Animation(0) = New _Animation(0,0,14,20,1)
   
   tmEngine.Map.BoundaryStyle = 1
   tmEngine.Map.BoundaryGrid  = 0
   
   'Fog setting
   'tmEngine.SetFog=200

   'Add cutout mask for map boundary
   'tmEngine.EnableMask = 1

   Sound.LoadMP3 ("sounds\loop.mp3",0)
   Sound.PlaySound (0,10)
   
   'Variables to control zooming
   Dim As Single zoom = 1
   Dim As Single zoominc = .01
   
	Do
		If tmEngine.GameClock.TickTime() Then

    	   'tmEngine.RenderLayer ( backdrop )
   	   tmEngine.RenderMap
   	   tmEngine.RenderObjects
   	   tmEngine.RenderLayer ( mist )
   	   tmEngine.RenderFog
   	   tmEngine.RenderMask
   	   'tmEngine.ShowMouse
   		
   		ScreenLock
   		
   		   Cls
   		   tmEngine.RenderSceneAt(20,40,zoom)
   		   
   		   'Process Zoom Factor ( Just zooming in an out )
   		   zoom += zoominc
   		   If zoom <1 Or zoom > 2 Then zoominc *= -1
   		
   		ScreenUnLock
		
         If MovePlayer (tmEngine, tmEngine.Object(0) ) Then
            tmEngine.Object(0).Animation->Pause = 0
            With tmEngine.Object(0)
               If .x < .lastx Then 
                  .Animation = walking(4)      
               EndIf     
               If .x > .lastx Then 
                  .Animation = walking(5)
               EndIf     
            End With
         Else
            tmEngine.Object(0).Animation->Pause = 1
         End If
         
         tmEngine.Camera.CenterOn( tmEngine.Object(0) )   
         
         'ProcessMouse    ( tmEngine )
         ProcessKeyboard ( tmEngine )

		End If

		Sleep 1,1
	
	Loop Until MultiKey(fb.SC_ESCAPE)

Sub ProcessMouse (tmEngine As _tmEngine)
Dim As Integer x,y,wh,btn,clip
Dim As _MapCell mapcell

   GetMouse x,y,wh,btn
   Select Case btn
      Case 1
         'Convert mouse coord to tile coords
         tmEngine.GetMouseTile(x,y) 
         'mapcell = tmEngine.Map.BuildCell(x,y,SpriteIdx,TileAttr,MapAnimIdx)
         mapcell = tmEngine.Map.BuildCell(1,0,0,0)
         tmEngine.Map.SetCell(x,y,mapcell)
      Case 2
         'Convert mouse coord to tile coords
         tmEngine.GetMouseTile(x,y) 
         'mapcell = tmEngine.Map.BuildCell(x,y,SpriteIdx,TileAttr,MapAnimIdx)
         mapcell = tmEngine.Map.BuildCell(0,0,0,0)
         tmEngine.Map.SetCell(x,y,mapcell)
   End Select
   
End Sub

Sub ProcessKeyboard(tmEngine As _tmEngine)

   If MultiKey(fb.SC_PLUS) Then
      'tmEngine.SetFog = tmEngine.Fog+1
      tmEngine.Object(0).rotangle+=15
   EndIf

   If MultiKey(fb.SC_MINUS) Then
      'tmEngine.SetFog = tmEngine.Fog-1
      tmEngine.Object(0).rotangle-=15
   EndIf
   
	If MultiKey(fb.SC_F1) Then 
		tmEngine.Map.SaveMap("map.dat")
	EndIf

End Sub

Function MovePlayer(tmEngine As _tmEngine, Object As _Object) As Integer
Dim As Integer keyflag,setflag = 0

   '---------------------------------------------
   Var lx = Object.x
   Var ly = Object.y         
	'---------------------------------------------
	If MultiKey(fb.SC_LEFT) Then 
		Object.MoveLeft
		setflag=1		
	EndIf
	If MultiKey(fb.SC_RIGHT) Then 
		Object.MoveRight
		setflag=1
	EndIf	
	keyflag Or= setflag
	   
   With Object
      If tmEngine.Map.Collision(Object) Then
         .x = lx
         setflag=0
      End If
   End With
   '---------------------------------------------         
	If MultiKey(fb.SC_UP) Then 
		Object.MoveUp
		setflag=1
	EndIf
	If MultiKey(fb.SC_DOWN) Then 
		Object.MoveDown
		setflag=1
	EndIf
	keyflag Or= setflag
   With Object
      If tmEngine.Map.Collision(Object) Then
         .y = ly
         setflag=0
      End If
   End With
   '---------------------------------------------
   ' This code will rotate the object in the direction
   ' that the arrow keys were pressed.
   '
   'If setflag Then
   '   Object.rotangle = Atn2(lx-Object.x,Object.y-ly)/(PI/180)
   'End If
   
   Return keyflag
   
End Function