/'--------------------------------------------------------------------
                  Nascent World Engine for FreeBASIC              
                     Copyright Vincent DeCampo 2009      

   This program is free software: you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

--------------------------------------------------------------------'/

#Ifndef PI
	Const PI = Atn(1)*4
	Const PI_180 = PI/180
#EndIf

#Define Atn2(x,y)       ATan2(y,x)

'-------------------------------------------------------------------
'                         		Collider
'-------------------------------------------------------------------
Type _tmCollider
	'
	Declare Constructor (MaxWidth As Integer, MaxHeight As Integer, BPP As Integer)
	Declare Destructor  () 
   '
	Declare Function Collision(Sprite1 As Any Ptr, X1 As Integer, Y1 As Integer, Sprite2 As Any Ptr, X2 As Integer, Y2 As Integer) As Integer
   '
	Container 	As Any Ptr
	BPP 			As Integer
	MXWidth		As Integer
	MXHeight		As Integer
   '
Private:
   '
   Declare Function ComparePixels32(Image1 As Any Ptr, Image2 As Any Ptr) As Integer
   Declare Function ComparePixels16(Image1 As Any Ptr, Image2 As Any Ptr) As Integer
   '
End Type

'-------------------------------------------------------------------
'                       		Game Math
'-------------------------------------------------------------------
Type _tmGameMath
	Declare Function DegToRad   (Deg As Single) As Single
	Declare Function RadToDeg   (Rad As Single) As Single
	Declare Function Distance   (x1 As Single, y1 As Single, x2 As Single, y2 As Single) As Single
	Declare Function OriginAngle(x As Single, y As Single) As Single
	Declare Function PolarX     (Deg As Integer, Radius As Single, WorldWidth As Integer) As Single
	Declare Function PolarY     (Deg As Integer, Radius As Single, WorldHeight As Integer) As Single
	Declare Function GetAngle   (OrgX As Single, OrgY As Single, x2 As Single, y2 As Single) As Single
	Declare Function GetAngleN  (OrgX As Single, OrgY As Single, x2 As Single, y2 As Single) As Single
	Declare Function NormalAng  (Ang As Single) As Single
	Declare Sub RotateCoords    (x As Single, y As Single, degRotation As Single, ByRef NewX As Single, ByRef NewY As Single)
	
Private:
	Dummy As Integer
End Type 

#Ifdef _MAKELIB_
   #Include Once "tmsupport.bas"
#endif
